class ApplicationMain
{

	#if waxe
	static public var frame : wx.Frame;
	static public var autoShowFrame : Bool = true;
	#if nme
	static public var nmeStage : wx.NMEStage;
	#end
	#end
	
	public static function main()
	{
		nme.Lib.setPackage("Tommislav", "seagal", "se.salomonsson.seagal", "1.0.0");
		
		
		#if waxe
		wx.App.boot(function()
		{
			
			frame = wx.Frame.create(null, null, "seagal", null, { width: 820, height: 480 });
			
			#if nme
			var stage = wx.NMEStage.create(frame, null, null, { width: 820, height: 480 });
			#end
			
			TestRunner.main();
			
			if (autoShowFrame)
			{
				wx.App.setTopWindow(frame);
				frame.shown = true;
			}
		});
		#else
		
		nme.Lib.create(function()
			{ 
				if (820 == 0 && 480 == 0)
				{
					nme.Lib.current.stage.align = nme.display.StageAlign.TOP_LEFT;
					nme.Lib.current.stage.scaleMode = nme.display.StageScaleMode.NO_SCALE;
				}
				
				TestRunner.main(); 
			},
			820, 480, 
			60, 
			0xFFFFFF,
			(true ? nme.Lib.HARDWARE : 0) |
			(true ? nme.Lib.RESIZABLE : 0) |
			(false ? nme.Lib.BORDERLESS : 0) |
			(false ? nme.Lib.VSYNC : 0) |
			(false ? nme.Lib.FULLSCREEN : 0) |
			(1 == 4 ? nme.Lib.HW_AA_HIRES : 0) |
			(1 == 2 ? nme.Lib.HW_AA : 0),
			"seagal"
			
			, getAsset("icon.png")
			
		);
		#end
		
	}
	
	
	public static function getAsset(inName:String):Dynamic
	{
		
		if (inName == "assets/block_32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/block_32.png");
			
		}
		
		if (inName == "assets/block_red.png")
		{
			
			return nme.Assets.getBitmapData ("assets/block_red.png");
			
		}
		
		if (inName == "assets/block_solidBottom_32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/block_solidBottom_32.png");
			
		}
		
		if (inName == "assets/block_transparent.png")
		{
			
			return nme.Assets.getBitmapData ("assets/block_transparent.png");
			
		}
		
		if (inName == "assets/block_white.png")
		{
			
			return nme.Assets.getBitmapData ("assets/block_white.png");
			
		}
		
		if (inName == "assets/block_white_transparent.png")
		{
			
			return nme.Assets.getBitmapData ("assets/block_white_transparent.png");
			
		}
		
		if (inName == "assets/floor_red.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_red.png");
			
		}
		
		if (inName == "assets/floor_red_32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_red_32.png");
			
		}
		
		if (inName == "assets/floor_red_32x32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_red_32x32.png");
			
		}
		
		if (inName == "assets/floor_shade_32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_shade_32.png");
			
		}
		
		if (inName == "assets/floor_shade_32x32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_shade_32x32.png");
			
		}
		
		if (inName == "assets/floor_transparent.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_transparent.png");
			
		}
		
		if (inName == "assets/floor_white.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_white.png");
			
		}
		
		if (inName == "assets/floor_white_32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_white_32.png");
			
		}
		
		if (inName == "assets/floor_white_32x32.png")
		{
			
			return nme.Assets.getBitmapData ("assets/floor_white_32x32.png");
			
		}
		
		return null;
	}
	
	
}