import LD25;
import nme.Assets;
import nme.events.Event;


class ApplicationMain {
	
	static var mPreloader:NMEPreloader;

	public static function main () {
		
		var call_real = true;
		
		
		var loaded:Int = nme.Lib.current.loaderInfo.bytesLoaded;
		var total:Int = nme.Lib.current.loaderInfo.bytesTotal;
		
		nme.Lib.current.stage.align = nme.display.StageAlign.TOP_LEFT;
		nme.Lib.current.stage.scaleMode = nme.display.StageScaleMode.NO_SCALE;
		
		if (loaded < total || true) /* Always wait for event */ {
			
			call_real = false;
			mPreloader = new NMEPreloader();
			nme.Lib.current.addChild(mPreloader);
			mPreloader.onInit();
			mPreloader.onUpdate(loaded,total);
			nme.Lib.current.addEventListener (nme.events.Event.ENTER_FRAME, onEnter);
			
		}
		
		
		
		haxe.Log.trace = flashTrace; // null
		

		if (call_real)
			begin ();
	}

	
	private static function flashTrace( v : Dynamic, ?pos : haxe.PosInfos ) {
		var className = pos.className.substr(pos.className.lastIndexOf('.') + 1);
		var message = className+"::"+pos.methodName+":"+pos.lineNumber+": " + v;

        if (flash.external.ExternalInterface.available)
			flash.external.ExternalInterface.call("console.log", message);
		else untyped flash.Boot.__trace(v, pos);
    }
	
	
	private static function begin () {
		
		var hasMain = false;
		
		for (methodName in Type.getClassFields(LD25))
		{
			if (methodName == "main")
			{
				hasMain = true;
				break;
			}
		}
		
		if (hasMain)
		{
			Reflect.callMethod (LD25, Reflect.field (LD25, "main"), []);
		}
		else
		{
			nme.Lib.current.addChild(cast (Type.createInstance(LD25, []), nme.display.DisplayObject));	
		}
		
	}

	static function onEnter (_) {
		
		var loaded:Int = nme.Lib.current.loaderInfo.bytesLoaded;
		var total:Int = nme.Lib.current.loaderInfo.bytesTotal;
		mPreloader.onUpdate(loaded,total);
		
		if (loaded >= total) {
			
			nme.Lib.current.removeEventListener(nme.events.Event.ENTER_FRAME, onEnter);
			mPreloader.addEventListener (Event.COMPLETE, preloader_onComplete);
			mPreloader.onLoaded();
			
		}
		
	}

	public static function getAsset (inName:String):Dynamic {
		
		
		if (inName=="img/BackgroundTiles.png")
			 
            return Assets.getBitmapData ("img/BackgroundTiles.png");
         
		
		if (inName=="img/backstory.png")
			 
            return Assets.getBitmapData ("img/backstory.png");
         
		
		if (inName=="img/levelmap.gif")
			 
            return Assets.getBitmapData ("img/levelmap.gif");
         
		
		if (inName=="img/sheet1.png")
			 
            return Assets.getBitmapData ("img/sheet1.png");
         
		
		if (inName=="img/shopScreen.png")
			 
            return Assets.getBitmapData ("img/shopScreen.png");
         
		
		if (inName=="img/shop_select.png")
			 
            return Assets.getBitmapData ("img/shop_select.png");
         
		
		if (inName=="img/splashScreen.png")
			 
            return Assets.getBitmapData ("img/splashScreen.png");
         
		
		
		return null;
		
	}
	
	
	private static function preloader_onComplete (event:Event):Void {
		
		mPreloader.removeEventListener (Event.COMPLETE, preloader_onComplete);
		
		nme.Lib.current.removeChild(mPreloader);
		mPreloader = null;
		
		begin ();
		
	}
	
}


class NME_img_backgroundtiles_png extends nme.display.BitmapData { public function new () { super (0, 0); } }
class NME_img_backstory_png extends nme.display.BitmapData { public function new () { super (0, 0); } }
class NME_img_levelmap_gif extends nme.display.BitmapData { public function new () { super (0, 0); } }
class NME_img_sheet1_png extends nme.display.BitmapData { public function new () { super (0, 0); } }
class NME_img_shopscreen_png extends nme.display.BitmapData { public function new () { super (0, 0); } }
class NME_img_shop_select_png extends nme.display.BitmapData { public function new () { super (0, 0); } }
class NME_img_splashscreen_png extends nme.display.BitmapData { public function new () { super (0, 0); } }

